/*
 * systemTime.c
 *
 *  Created on: 08.07.2011
 *      Author: jmm
 */
#include <avr/interrupt.h>
#include "timelib.h"

// Datenblatt: Prescalerwerte für CS2[0..2]
#if (PS == 1)
	#define PSOR	1
#elif (PS == 8)
	#define PSOR	2
#elif (PS == 32)
	#define PSOR	3
#elif (PS == 64)
	#define PSOR	4
#elif (PS == 128)
	#define PSOR	5
#elif (PS == 256)
	#define PSOR	6
#elif (PS == 1024)
	#define PSOR	7
#endif
// Wir wollen Echtzeit
#define COMP		(EPSILON * F_CPU / PS)

volatile timeT systemTime;

ISR(TIMER2_COMP_vect) {
	// Bei Überlauf: Anhalten
	if(!(++systemTime))
		for(;;);
}

inline void systemtime_init() {
	systemTime = 0;
	TCCR2 = (1 << FOC2)
		| (1 << WGM21) | (0 << WGM20)
		| (0 << COM21) | (0 << COM20)
		| (PSOR << CS20); // Prescaler
	OCR2 = COMP;
	// Compare Interrupt Timer 2
	sbi(TIMSK, OCIE2);
}
